## Third_party_open_source.zip

=== Makefile ===
export REPOSITORY=flyte
include boilerplate/flyte/end2end/Makefile
include boilerplate/flyte/golang_test_targets/Makefile

define PIP_COMPILE
pip-compile $(1) --upgrade --verbose --resolver=backtracking --annotation-style=line
endef

GIT_VERSION := $(shell git describe --tags --long --match "v*" --first-parent)
GIT_HASH := $(shell git rev-parse --short HEAD)
TIMESTAMP := $(shell date '+%Y-%m-%d')
PACKAGE ?=github.com/flyteorg/flyte/flytestdlib
LD_FLAGS="-s -w -X $(PACKAGE)/version.Version=$(GIT_VERSION) -X $(PACKAGE)/version.Build=$(GIT_HASH) -X $(PACKAGE)/version.BuildTime=$(TIMESTAMP)"
TMP_BUILD_DIR := .tmp_build

.PHONY: cmd/single/dist
cmd/single/dist: export FLYTECONSOLE_VERSION ?= latest
cmd/single/dist:
	script/get_flyteconsole_dist.sh

.PHONY: compile
compile: cmd/single/dist
	go build -tags console -v -o flyte -ldflags=$(LD_FLAGS) ./cmd/
	mv ./flyte ${GOPATH}/bin/ || echo "Skipped copying 'flyte' to ${GOPATH}/bin"

.PHONY: linux_compile
linux_compile: cmd/single/dist
	GOOS=linux GOARCH=amd64 CGO_ENABLED=0  go build -tags console -v -o /artifacts/flyte -ldflags=$(LD_FLAGS) ./cmd/

.PHONY: update_boilerplate
update_boilerplate:
	@boilerplate/update.sh

.PHONY: helm
helm: ## Generate K8s Manifest from Helm Charts.
	bash script/generate_helm.sh
	make -C docker/sandbox-bundled manifests

.PHONY: release_automation
release_automation:
	mkdir -p release
	bash script/release.sh
	bash script/generate_config_docs.sh
	$(MAKE) -C docker/sandbox-bundled manifests

.PHONY: deploy_sandbox
deploy_sandbox:
	bash script/deploy.sh

.PHONY: install-piptools
install-piptools: ## Install pip-tools
	pip install -U pip-tools

.PHONY: install-conda-lock
install-conda-lock:
	pip install conda-lock

.PHONY: conda-lock
conda-lock: install-conda-lock
	conda-lock -f monodocs-environment.yaml --without-cuda \
		--lockfile monodocs-environment.lock.yaml \
		--platform=osx-64 --platform=osx-arm64 --platform=linux-64

.PHONY: stats
stats:
	@generate-dashboard -o deployment/stats/prometheus/flytepropeller-dashboard.json stats/flytepropeller.dashboard.py
	@generate-dashboard -o deployment/stats/prometheus/flyteadmin-dashboard.json stats/flyteadmin.dashboard.py
	@generate-dashboard -o deployment/stats/prometheus/flyteuser-dashboard.json stats/flyteuser.dashboard.py

.PHONY: prepare_artifacts
prepare_artifacts:
	bash script/prepare_artifacts.sh

.PHONE: helm_update
helm_update: ## Update helm charts' dependencies.
	helm dep update ./charts/flyte/

.PHONY: helm_install
helm_install: ## Install helm charts
	helm install flyte --debug ./charts/flyte -f ./charts/flyte/values.yaml --create-namespace --namespace=flyte

.PHONY: helm_upgrade
helm_upgrade: ## Upgrade helm charts
	helm upgrade flyte --debug ./charts/flyte -f ./charts/flyte/values.yaml --create-namespace --namespace=flyte

# Used in CI
.PHONY: docs
docs:
	make -C docs clean html SPHINXOPTS=-W

$(TMP_BUILD_DIR):
	mkdir $@

$(TMP_BUILD_DIR)/conda-lock-image: docs/Dockerfile.conda-lock | $(TMP_BUILD_DIR)
	docker buildx build --load --platform=linux/amd64 --build-arg USER_UID=$$(id -u) --build-arg USER_GID=$$(id -g) -t flyte-conda-lock:latest -f docs/Dockerfile.conda-lock .
	touch $(TMP_BUILD_DIR)/conda-lock-image

monodocs-environment.lock.yaml: monodocs-environment.yaml $(TMP_BUILD_DIR)/conda-lock-image
	docker run --platform=linux/amd64 --rm --pull never -v ./:/flyte flyte-conda-lock:latest lock --file monodocs-environment.yaml --lockfile monodocs-environment.lock.yaml

$(TMP_BUILD_DIR)/dev-docs-image: docs/Dockerfile.docs monodocs-environment.lock.yaml | $(TMP_BUILD_DIR)
	docker buildx build --load --platform=linux/amd64 --build-arg USER_UID=$$(id -u) --build-arg USER_GID=$$(id -g) -t flyte-dev-docs:latest -f docs/Dockerfile.docs .
	touch $(TMP_BUILD_DIR)/dev-docs-image

# Build docs in docker container for local development
.PHONY: dev-docs
dev-docs: $(TMP_BUILD_DIR)/dev-docs-image
	bash script/local_build_docs.sh

.PHONY: help
help: SHELL := /bin/sh
help: ## List available commands and their usage
	@awk 'BEGIN {FS = ":.*?##"; printf "\nUsage:\n  make \033[36m<target>\033[0m\n\nTargets:\n"} /^[0-9a-zA-Z_-]+:.*?##/ { printf "  \033[36m%-20s\033[0m %s\n", $$1, $$2 } ' $(MAKEFILE_LIST)

.PHONY: setup_local_dev
setup_local_dev: ## Sets up k3d cluster with Flyte dependencies for local development
	@bash script/setup_local_dev.sh

# This builds the flyte binary image for whatever architecture you're on. Don't push this image to the official
# registry because we need those to be multi-arch.
.PHONY: build_native_flyte
build_native_flyte: FLYTECONSOLE_VERSION := latest
build_native_flyte:
	docker build \
	--build-arg FLYTECONSOLE_VERSION=$(FLYTECONSOLE_VERSION) \
	--tag flyte-binary:native .

.PHONY: go-tidy
go-tidy:
	go mod tidy
	make -C datacatalog go-tidy
	make -C flyteadmin go-tidy
	make -C flyteidl go-tidy
	make -C flytepropeller go-tidy
	make -C flyteplugins go-tidy
	make -C flytestdlib go-tidy
	make -C flytecopilot go-tidy
	make -C flytectl go-tidy

.PHONY: lint-helm-charts
lint-helm-charts:
	# This pressuposes that you have act installed
	act pull_request -W .github/workflows/validate-helm-charts.yaml --container-architecture linux/amd64 -e charts/event.json

.PHONY: spellcheck
spellcheck:
	act pull_request --container-architecture linux/amd64 -W .github/workflows/codespell.yml

.PHONY: clean
clean: ## Remove the HTML files related to the Flyteconsole and Makefile
	rm -rf cmd/single/dist .tmp_build

=== meson_options.txt ===
# Directories
option(
  'distconfdir',
  type : 'string',
  description : 'Directory to search for distribution configuration files. ' +
                'Default: $prefix/lib',
)

option(
  'moduledir',
  type : 'string',
  description : 'Directory to look for kernel modules. Default: /lib/modules',
)

option(
  'bashcompletiondir',
  type : 'string',
  description : 'Bash completions directory. Use "no" to disable.',
)

option(
  'fishcompletiondir',
  type : 'string',
  description : 'Fish completions directory. Use "no" to disable.',
)

option(
  'zshcompletiondir',
  type : 'string',
  description : 'Zsh completions directory. Use "no" to disable.',
)

# Compression options
option(
  'zstd',
  type : 'feature',
  value : 'disabled',
  description : 'Handle Zstandard-compressed modulesi. Default: disabled',
)

option(
  'xz',
  type : 'feature',
  value : 'disabled',
  description : 'Handle Xz-compressed modules. Default: disabled',
)

option(
  'zlib',
  type : 'feature',
  value : 'disabled',
  description : 'Handle gzip-compressed modules. Default: disabled',
)

# Signed modules
option(
  'openssl',
  type : 'feature',
  value : 'disabled',
  description : 'Openssl support, PKCS7 signatures. Default: disabled',
)

option(
  'tools',
  type : 'boolean',
  value : true,
  description : 'Build the tools - kmod, depmod, lsmod ... Default: true',
)

option(
  'logging',
  type : 'boolean',
  value : true,
  description : 'Build with system logging. Default: true',
)

option(
  'debug-messages',
  type : 'boolean',
  value : false,
  description : 'Enable debug messages. Default: false',
)

# XXX: workaround a meson bug, where the tests are always build even
# when explicitly annotated as "build_by_default: false"
# See: https://github.com/mesonbuild/meson/issues/2518
option(
  'build-tests',
  type : 'boolean',
  value : false,
  description : 'Always build the test suite. Default: false',
)

option(
  'manpages',
  type : 'boolean',
  value : true,
  description : 'Build the manpages. Default: true',
)

option(
  'docs',
  type : 'boolean',
  value : false,
  description : 'Build the documentation. Default: false',
)

=== requirements.txt ===
Cython>=3.0.0
pytest>=6.2.4
pytest-benchmark>=3.4.1
numpy>=1.21.1
pyclibrary>=0.1.7
setuptools
tomli; python_version < "3.11"
versioneer==0.29
wheel
pywin32; sys_platform == 'win32'

=== bootloader/wscript ===
#!/usr/bin/env python3
# -----------------------------------------------------------------------------
# Copyright (c) 2014-2023, PyInstaller Development Team.
#
# Distributed under the terms of the GNU General Public License (version 2
# or later) with exception for distributing the bootloader.
#
# The full license is in the file COPYING.txt, distributed with this software.
#
# SPDX-License-Identifier: (GPL-2.0-or-later WITH Bootloader-exception)
# -----------------------------------------------------------------------------
"""
Bootloader building script.
"""

import os
import platform
import sys
import re
import sysconfig
from waflib.Configure import conf
from waflib import Logs, Utils, Options
from waflib.Build import BuildContext, InstallContext

# waf does not work unless it is ran from in this folder, so it is safe to assume the current working directory here.
sys.path.insert(0, os.path.realpath("../PyInstaller/"))
import _shared_with_waf  # noqa: E402

# The following two variables are used by the target "waf dist"
VERSION = 'nodist'
APPNAME = 'PyInstallerBootloader'

# These variables are mandatory ('/' are converted automatically)
top = '.'
out = 'build'

# Build variants of bootloader.
# PyInstaller provides debug/release bootloaders and console/windowed variants. Each variant has a different exe name.
variants = {
    'debug': 'run_d',
    'debugw': 'runw_d',
    'release': 'run',
    'releasew': 'runw',
}

# PyInstaller only knows platform.system(), so we need to map waf's DEST_OS to these values.
DESTOS_TO_SYSTEM = {
    'linux': 'Linux',
    'freebsd': 'FreeBSD',
    'openbsd': 'OpenBSD',
    'win32': 'Windows',
    'darwin': 'Darwin',
    'sunos': platform.system(),  # FIXME: inhibits cross-compile
    'hpux': 'HP-UX',
    'aix': 'AIX',
    'cygwin': 'Cygwin',
}

# Map from platform.system() to waf's DEST_OS
SYSTEM_TO_BUILDOS = {
    'Linux': 'linux',
    'FreeBSD': 'freebsd',
    'Windows': 'win32',
    'Darwin': 'darwin',
    'Solaris': 'sunos',
    'SunOS': 'sunos',
    'HP-UX': 'hpux',
    'AIX': 'aix',
    'Cygwin': 'cygwin',
}

# waf's name of the system we are building on
if sys.platform == 'cygwin':
    # Cygwin needs special handling, because platform.system() contains identifiers such as MSYS_NT-10.0-19042 and
    # CYGWIN_NT-10.0-19042 that do not fit PyInstaller's OS naming scheme, nor waf's DEST_OS, which is 'cygwin'.
    BUILD_OS = SYSTEM_TO_BUILDOS.get('Cygwin')
else:
    BUILD_OS = SYSTEM_TO_BUILDOS.get(platform.system(), platform.system())

is_cross = None


def machine(ctx):
    """
    Determine path to bootloader based on C compiler target.
    """
    return _shared_with_waf._pyi_machine(ctx.env.DEST_CPU, DESTOS_TO_SYSTEM[ctx.env.DEST_OS])


def is_msvc_target(ctx):
    """
    clang may be compiled to use either MSVC's headers or mingw's. If it's the former, it inherits some of MSVC's
    quirks.
    """
    if ctx.env.CC_NAME == 'clang':
        from subprocess import run, PIPE
        spec = run(ctx.env.CC + ["-v"], stderr=PIPE).stderr
        return re.search(rb'Target: .*msvc', spec)
    return ctx.env.CC_NAME == 'msvc'


@conf
def is_musl(ctx):
    """Return true if the C compiler targets Linux using musl libc. Always false on non-Linux."""
    if ctx.env.DEST_OS != 'linux':
        return False
    from subprocess import run, PIPE
    spec = run(ctx.env.CC + ["-v"], stderr=PIPE).stderr
    return re.search(rb'--target=\S+-musl', spec) or re.search(rb'Target: .*musl', spec)


def find_program_next_to_cc(ctx, name, var):
    # Tries to find a program in the same directory as cc or on the normal PATH.
    environ = getattr(ctx, 'environ', os.environ)
    path = [os.path.dirname(ctx.env.CC[0])]
    path.extend(environ.get('PATH', '').split(os.pathsep))
    ctx.find_program(name, var=var, path_list=path)


def options(ctx):
    ctx.load('compiler_c')

    ctx.add_option(
        '--debug',
        action='store_true',
        help='Include debugging info for GDB.',
        default=False,
        dest='debug',
    )
    ctx.add_option(
        '--leak-detector',
        action='store_true',
        help='Link with Boehm garbage collector to detect memory leaks.',
        default=False,
        dest='boehmgc',
    )
    ctx.add_option(
        '--clang',
        action='store_true',
        help='Try to find clang C compiler instead of gcc.',
        default=False,
        dest='clang',
    )
    ctx.add_option(
        '--gcc',
        action='store_true',
        help='Try to find GNU C compiler.',
        default=False,
        dest='gcc',
    )
    ctx.add_option(
        '--target-arch',
        action='store',
        help='Target architecture format (32bit, 64bit). This option allows to build 32-bit bootloader with a 64-bit '
        'compiler and a 64-bit Python.',
        default=None,
        choices=('32bit', '64bit', '64bit-arm'),
        dest='target_arch',
    )
    ctx.add_option(
        '--static-zlib',
        action='store_true',
        help='Statically compile zlib into the bootloaders rather than dynamically linking to the system-wide copy. '
        'This is always done on Windows.',
        default=False,
    )
    ctx.add_option(
        '--tests',
        action='store_true',
        help='Enable cmocka-based tests if cmocka library is found. The tests are disabled by default.',
        default=False,
        dest='enable_tests',
    )
    ctx.add_option(
        '--no-tests',
        action='store_false',
        help='Disable cmocka-based tests, even if cmocka library is found. The tests are disabled by default.',
        default=False,
        dest='enable_tests',
    )

    grp = ctx.add_option_group('macOS-specific options', 'These options have effect only on macOS.')
    grp.add_option(
        '--universal2',
        action='store_true',
        help='When building for 64-bit platform, build universal2 fat binary (x86_64, arm64). This is the default.',
        default=None,
        dest='macos_universal2',
    )
    grp.add_option(
        '--no-universal2',
        action='store_false',
        help="When building for 64-bit platform, build a thin binary. Allows building with older toolchains that do "
        "not support universal2 binaries. The resultant architecture is determined by the compiler's default, which "
        "is usually to build a native executable. This may be overridden by setting the CC environment variable, e.g., "
        "CC='clang -arch=arm64' python waf all",
        default=None,
        dest='macos_universal2',
    )


def check_sizeof_pointer(ctx):
    def check(type, expected):
        # test code taken from autoconf resp. Scons: this is a pretty clever hack to find that a type is of a given
        # size using only compilation. This speeds things up quite a bit compared to straightforward code actually
        # running the code. Plus: This works cross :-)
        fragment = '''
        int main() {
            static int test_array[1 - 2 * !(sizeof(%s) == %d)];
            test_array[0] = 0;
            return 0;
        }''' % (type, expected)
        return ctx.check_cc(fragment=fragment, execute=False, mandatory=False)

    ctx.start_msg("Checking size of pointer")
    for size in (4, 8):
        if check("void *", size):
            break
    else:
        ctx.end_msg(False)
        ctx.fatal(
            "Could not determine pointer size. Use `--target-arch' to manually set the pointer size (32bit or 64bit)."
        )
    ctx.end_msg(size)
    return size


@conf
def detect_arch(ctx):
    """
    Handle --target-arch options, or use the same architecture as the compiler.
    """
    try:
        system = DESTOS_TO_SYSTEM[ctx.env.DEST_OS]
    except KeyError:
        ctx.fatal('Unrecognized target system: %s' % ctx.env.DEST_OS)

    # Get arch values either from CLI or detect it.
    if ctx.options.target_arch:
        arch = ctx.options.target_arch
        ctx.msg('Platform', '%s-%s manually chosen' % (system, arch))
        ctx.env.ARCH_FLAGS_REQUIRED = True
        if arch == '64bit-arm':
            arch = '64bit'
            ctx.env.DEST_CPU = 'arm64'
    else:
        # PyInstaller uses the result of platform.architecture() to determine the bits and this is testing the pointer
        # size (via module struct). We do the same here.
        arch = "%sbit" % (8 * check_sizeof_pointer(ctx))
        _machine = machine(ctx)
        if _machine is not None:
            plat = '%s-%s-%s detected based on compiler' % (system, arch, _machine)
        else:
            plat = '%s-%s detected based on compiler' % (system, arch)
        ctx.msg('Platform', plat)
        ctx.env.ARCH_FLAGS_REQUIRED = False
    if arch not in ('32bit', '64bit'):
        ctx.fatal('Unrecognized target architecture: %s' % arch)

    # Pass return values as environment variables.
    ctx.env.PYI_ARCH = arch  # '32bit' or '64bit'
    ctx.env.PYI_SYSTEM = system


@conf
def set_arch_flags(ctx):
    """
    Set proper architecture flag (32-bit or 64-bit), cflags for compiler, and CPU target for compiler.
    """
    def check_arch_cflag(cflag32, cflag64):
        cflag = cflag32 if ctx.env.PYI_ARCH == '32bit' else cflag64
        # features='c' -> only compile, do not link
        if ctx.check_cc(cflags=cflag, features='c', mandatory=ctx.env.ARCH_FLAGS_REQUIRED):
            ctx.env.append_value('CFLAGS', cflag)
        if ctx.check_cc(linkflags=cflag, mandatory=ctx.env.ARCH_FLAGS_REQUIRED):
            ctx.env.append_value('LINKFLAGS', cflag)

    if ctx.env.DEST_OS == 'win32' and ctx.env.CC_NAME == 'msvc':
        # Set msvc linkflags based on architecture.
        if machine(ctx) == 'arm':
            ctx.env.append_value('LINKFLAGS', '/MACHINE:ARM64')
        elif ctx.env.PYI_ARCH == '32bit':
            ctx.env.append_value('LINKFLAGS', '/MACHINE:X86')
            # Set LARGE_ADDRESS_AWARE_FLAG to True. On Windows, this allows 32-bit apps to use 4GB of memory.
            ctx.env.append_value('LINKFLAGS', '/LARGEADDRESSAWARE')
        elif ctx.env.PYI_ARCH == '64bit':
            ctx.env.append_value('LINKFLAGS', '/MACHINE:X64')
        ctx.env['MSVC_TARGETS'] = _msvc_target(ctx)

        # Enable 64-bit porting warnings and other warnings.
        ctx.env.append_value('CFLAGS', '/W3')
        # Disable warnings about unrecognized pragmas.
        ctx.env.append_value('CFLAGS', '/wd4068')
        # Disable warnings about deprecated POSIX function names.
        ctx.env.append_value('CFLAGS', '/D_CRT_NONSTDC_NO_WARNINGS')
        # Disable warnings about unsafe CRT functions.
        ctx.env.append_value('CFLAGS', '/D_CRT_SECURE_NO_WARNINGS')
        # We use SEH exceptions in winmain.c; make sure they are activated.
        ctx.env.append_value('CFLAGS', '/EHa')
        # Set the PE checksum on resulting binary.
        ctx.env.append_value('LINKFLAGS', '/RELEASE')

    # Ensure proper architecture flags on Mac OS.
    elif ctx.env.DEST_OS == 'darwin':
        # Default compiler on Mac OS X is Clang, which does not have '-m32' and '-m64' flags.
        if ctx.env.PYI_ARCH == '32bit':
            mac_arch = ['-arch', 'i386']
        else:
            UNIVERSAL2_FLAGS = ['-arch', 'x86_64', '-arch', 'arm64']
            if ctx.options.macos_universal2 in (None, True):
                # Check for universal2 support if set to auto-detect (neither --universal2 nor --no-universal2 is
                # provided), or if universal2 is explicitly enabled.
                supported = ctx.check_cc(
                    cflags=UNIVERSAL2_FLAGS,
                    linkflags=UNIVERSAL2_FLAGS,
                    features='c cprogram',
                    msg='Checking for universal2 support',
                    mandatory=ctx.options.macos_universal2
                )
                ctx.options.macos_universal2 = supported
            if ctx.options.macos_universal2:
                mac_arch = UNIVERSAL2_FLAGS
            else:
                # Default to whatever the compiler is configured to build.

=== datacatalog/Makefile ===
export REPOSITORY=datacatalog
export REPO_ROOT=..
include ../boilerplate/flyte/docker_build/Makefile
include ../boilerplate/flyte/golang_test_targets/Makefile

.PHONY: compile
compile:
	mkdir -p ./bin
	go build -o bin/datacatalog ./cmd/main.go

.PHONY: linux_compile
linux_compile: export CGO_ENABLED ?= 0
linux_compile: export GOOS ?= linux
linux_compile:
	go build -o /artifacts/datacatalog ./cmd/

=== docs/Makefile ===
# Minimal makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
SPHINXPROJ    = flyte
SOURCEDIR     = .
BUILDDIR      = _build

# Put it first so that "make" without argument is like "make help".
help:
	@$(SPHINXBUILD) -M help "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

.PHONY: help Makefile

# Catch-all target: route all unknown targets to Sphinx using the new
# "make mode" option.  $(O) is meant as a shortcut for $(SPHINXOPTS).
%: Makefile
	@$(SPHINXBUILD) -M $@ "$(SOURCEDIR)" "$(BUILDDIR)" $(SPHINXOPTS) $(O)

clean:
	rm -rf _build _src _tags api/flytectl api/flytekit flytesnacks protos examples tests _projects

=== flyteadmin/Makefile ===
export REPOSITORY=flyteadmin
export FLYTE_SCHEDULER_REPOSITORY=flytescheduler
export REPO_ROOT=..
include ../boilerplate/flyte/docker_build/Makefile
include ../boilerplate/flyte/golang_test_targets/Makefile
include ../boilerplate/flyte/end2end/Makefile

GIT_VERSION := $(shell git describe --tags --long --match "v*" --first-parent)
GIT_HASH := $(shell git rev-parse --short HEAD)
TIMESTAMP := $(shell date '+%Y-%m-%d')
# TODO(monorepo): Do we need to change this? This is used in the service that provides a version.
PACKAGE ?=github.com/flyteorg/flyte/flytestdlib

LD_FLAGS="-s -w -X $(PACKAGE)/version.Version=$(GIT_VERSION) -X $(PACKAGE)/version.Build=$(GIT_HASH) -X $(PACKAGE)/version.BuildTime=$(TIMESTAMP)"

.PHONY: update_boilerplate
update_boilerplate:
	@curl https://raw.githubusercontent.com/flyteorg/boilerplate/master/boilerplate/update.sh -o boilerplate/update.sh
	@boilerplate/update.sh

.PHONY: docker_build_scheduler
docker_build_scheduler:
	docker build -t $$FLYTE_SCHEDULER_REPOSITORY:$(GIT_HASH) -f Dockerfile.scheduler .

.PHONY: integration
integration: export CGO_ENABLED ?= 0
integration: export GOFLAGS ?= -count=1
integration:
	go test -v -tags=integration ./tests/...

.PHONY: k8s_integration
k8s_integration:
	@script/integration/launch.sh

.PHONY: k8s_integration_execute
k8s_integration_execute:
	@script/integration/execute.sh

.PHONY: compile
compile:
	mkdir -p ./bin
	go build -o bin/flyteadmin -ldflags=$(LD_FLAGS) ./cmd/

.PHONY: compile_debug
compile_debug:
	go build -o flyteadmin -gcflags='all=-N -l' ./cmd/ && mv ./flyteadmin ${GOPATH}/bin


.PHONY: compile_scheduler
compile_scheduler:
	mkdir -p ./bin
	go build -o bin/flytescheduler -ldflags=$(LD_FLAGS) ./cmd/scheduler/

.PHONY: compile_scheduler_debug
compile_scheduler_debug:
	go build -o flytescheduler -gcflags='all=-N -l' ./cmd/scheduler/ && mv ./flytescheduler ${GOPATH}/bin


.PHONY: linux_compile
linux_compile: export CGO_ENABLED ?= 0
linux_compile: export GOOS ?= linux
linux_compile:
	go build -o /artifacts/flyteadmin -ldflags=$(LD_FLAGS) ./cmd/

.PHONY: linux_compile_scheduler
linux_compile_scheduler: export CGO_ENABLED ?= 0
linux_compile_scheduler: export GOOS ?= linux
linux_compile_scheduler:
	go build -o /artifacts/flytescheduler -ldflags=$(LD_FLAGS) ./cmd/scheduler/

.PHONY: server
server:
	go run cmd/main.go serve  --server.kube-config ~/.kube/config  --config flyteadmin_config.yaml

.PHONY: scheduler
scheduler:
	go run cmd/scheduler/main.go run  --server.kube-config ~/.kube/config  --config flyteadmin_config.yaml

.PHONY: migrate
migrate:
	go run cmd/main.go migrate run --server.kube-config ~/.kube/config  --config flyteadmin_config.yaml

.PHONY: seed_projects
seed_projects:
	go run cmd/main.go migrate seed-projects project admintests flytekit --server.kube-config ~/.kube/config  --config flyteadmin_config.yaml

all: compile

=== flytecopilot/Makefile ===
export REPOSITORY=flytecopilot
export REPO_ROOT=..
include ../boilerplate/flyte/docker_build/Makefile
include ../boilerplate/flyte/golang_test_targets/Makefile

.PHONY: update_boilerplate
update_boilerplate:
	@curl https://raw.githubusercontent.com/flyteorg/boilerplate/master/boilerplate/update.sh -o boilerplate/update.sh
	@boilerplate/update.sh

clean:
	rm -rf bin

.PHONY: linux_compile
linux_compile: export CGO_ENABLED ?= 0
linux_compile: export GOOS ?= linux
linux_compile:
	go build -o /artifacts/flyte-copilot .

.PHONY: compile
compile:
	mkdir -p ./artifacts
	go build -o ./artifacts/flyte-copilot .

cross_compile:
	@mkdir -p ./artifacts/cross
	GOOS=linux GOARCH=amd64 go build -o ./artifacts/flyte-copilot .

=== flytectl/Makefile ===
export REPOSITORY=flytectl
export REPO_ROOT=..
include ../boilerplate/flyte/docker_build/Makefile
include ../boilerplate/flyte/golang_test_targets/Makefile
include ../boilerplate/flyte/end2end/Makefile

GIT_VERSION := $(shell git describe --dirty --tags --long --match 'flytectl/*' --first-parent | sed 's/^flytectl\///')
GIT_HASH := $(shell git rev-parse --short HEAD)
TIMESTAMP := $(shell date '+%Y-%m-%d')
PACKAGE ?=github.com/flyteorg/flyte/flytestdlib

LD_FLAGS="-s -w -X $(PACKAGE)/version.Version=$(GIT_VERSION) -X $(PACKAGE)/version.Build=$(GIT_HASH) -X $(PACKAGE)/version.BuildTime=$(TIMESTAMP)"

define PIP_COMPILE
pip-compile $(1) --upgrade --verbose
endef

compile:
	go build -o bin/flytectl -ldflags=$(LD_FLAGS) main.go

compile_debug:
	go build -gcflags='all=-N -l' -o bin/flytectl main.go

.PHONY: update_boilerplate
update_boilerplate:
	@curl https://raw.githubusercontent.com/flyteorg/boilerplate/master/boilerplate/update.sh -o boilerplate/update.sh
	@boilerplate/update.sh

.PHONY: install-piptools
install-piptools:
	pip install -U pip-tools

.PHONY: test_unit_without_flag
test_unit_without_flag:
	go test ./... -race -coverprofile=coverage.temp.txt -covermode=atomic
	cat coverage.temp.txt  | grep -v "_flags.go" > coverage.txt
	rm coverage.temp.txt
	curl -s https://codecov.io/bash > codecov_bash.sh && bash codecov_bash.sh

=== flyteidl/Makefile ===
export REPOSITORY=flyteidl
export REPO_ROOT=..
include ../boilerplate/flyte/golang_test_targets/Makefile

define PIP_COMPILE
pip-compile $(1) --upgrade --verbose
endef

.PHONY: generate
generate: install # install tools, generate protos, mock, pflags and  get doc dependencies
	./generate_protos.sh
	./generate_mocks.sh
	go generate ./...

.PHONY: test
test: install # ensures generate_protos script has been run
	git diff
	./generate_mocks.sh
	go generate ./...
	DELTA_CHECK=true ./generate_protos.sh

.PHONY: test_unit
test_unit:
	# we cannot use test_unit from go.mk because generated files contain commented import statements that
	# go tries to interpret. So we need to use go list to get the packages that go understands.
	go test -cover `go list ./...` -race

.PHONY: build_python
build_python:
	@python setup.py sdist

.PHONY: install-piptools
install-piptools:
	pip install -U pip-tools

PLACEHOLDER_NPM := \"version\": \"0.0.0-develop\"

.PHONY: update_npmversion
update_npmversion:
	grep "$(PLACEHOLDER_NPM)" "package.json"
	sed -i "s/$(PLACEHOLDER_NPM)/\"version\":  \"${VERSION}\"/g" "package.json"

=== flyteplugins/Makefile ===
export REPOSITORY=flyteplugins
export REPO_ROOT=..
include ../boilerplate/flyte/docker_build/Makefile
include ../boilerplate/flyte/golang_test_targets/Makefile

.PHONY: update_boilerplate
update_boilerplate:
	@curl https://raw.githubusercontent.com/flyteorg/boilerplate/master/boilerplate/update.sh -o boilerplate/update.sh
	@boilerplate/update.sh

=== flytepropeller/Makefile ===
export REPOSITORY=flytepropeller
export REPO_ROOT=..
include ../boilerplate/flyte/docker_build/Makefile
include ../boilerplate/flyte/golang_test_targets/Makefile
include ../boilerplate/flyte/end2end/Makefile

.PHONY: update_boilerplate
update_boilerplate:
	@curl https://raw.githubusercontent.com/flyteorg/boilerplate/master/boilerplate/update.sh -o boilerplate/update.sh
	@boilerplate/update.sh

.PHONY: linux_compile
linux_compile: export CGO_ENABLED ?= 0
linux_compile: export GOOS ?= linux
linux_compile:
	go build -o /artifacts/flytepropeller ./cmd/controller/main.go
	go build -o /artifacts/flytepropeller-manager ./cmd/manager/main.go
	go build -o /artifacts/kubectl-flyte ./cmd/kubectl-flyte/main.go

.PHONY: compile
compile:
	mkdir -p ./bin
	go build -o bin/flytepropeller ./cmd/controller/main.go
	go build -o bin/flytepropeller-manager ./cmd/manager/main.go
	go build -o bin/kubectl-flyte ./cmd/kubectl-flyte/main.go

.PHONY: compile_flytepropeller
compile_flytepropeller:
	mkdir -p ./bin
	go build -o bin/flytepropeller ./cmd/controller/main.go

cross_compile:
	@glide install
	@mkdir -p ./bin/cross
	go build -o bin/cross/flytepropeller ./cmd/controller/main.go
	go build -o bin/cross/flytepropeller-manager ./cmd/manager/main.go
	go build -o bin/cross/kubectl-flyte ./cmd/kubectl-flyte/main.go

op_code_generate:
	@RESOURCE_NAME=flyteworkflow OPERATOR_PKG=github.com/flyteorg/flytepropeller ./hack/update-codegen.sh

benchmark:
	mkdir -p ./bin/benchmark
	@go test -run=^$ -bench=. -cpuprofile=cpu.out -memprofile=mem.out ./pkg/controller/nodes/. && mv *.out ./bin/benchmark/ && mv *.test ./bin/benchmark/

# server starts the service in development mode
.PHONY: server
server:
	@go run ./cmd/controller/main.go --alsologtostderr --propeller.kube-config=$(HOME)/.kube/config

# manager starts the manager service in development mode
.PHONY: manager
manager:
	@go run ./cmd/manager/main.go --alsologtostderr --propeller.kube-config=$(HOME)/.kube/config

clean:
	rm -rf bin

# Generate golden files. Add test packages that generate golden files here.
golden:
	go test ./cmd/kubectl-flyte/cmd -update
	go test ./pkg/compiler/test -update

=== debian/changelog ===
glibc (2.40-5) UNRELEASED; urgency=medium

  * debian/patches/hurd-i386/git-MAP_NORESERVE.diff: Add MAP_NORESERVE flag.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 25 Nov 2024 00:56:05 +0100

glibc (2.40-4) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/testsuite-xfail-debian.mk: Update hurd xfails.
  * debian/patches/hurd-i386/git-default_pager.h.diff: Ship
    mach/default_pager.h again.

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix memory corruption with ancient i386 binaries using stdio. Closes:
      #1080244.
    - Fix FTBFS with gcc-14 on hppa.  Closes: #1084052.
    - Drop debian/patches/sparc/submitted-sparc-clone.diff (merged).
  * debian/patches/arm/git-hwcap2-constants.diff: backport for upstream to
    support HWCAP2 values on arm32.  Closes: #1086502.
  * debian/control: add Recommends: libc-dev (= ${binary:Version}) to
    libc-devtools.  Closes: #1087881.

 -- Aurelien Jarno <aurel32@debian.org>  Sat, 23 Nov 2024 14:57:03 +0100

glibc (2.40-3) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/testsuite-xfail-debian.mk: Avoid tests overflowing memory.
  * debian/testsuite-xfail-debian.mk: Update hurd xfails.

  [ Aurelien Jarno ]
  * debian/rules: build with gcc-14.
  * debian/control.in/main: adjust g++-for-host version on arm64 to ensure
    PAC/BTI support.
  * debian/patches/git-updates.diff: update from upstream stable branch.
  * debian/patches/any/git-iconv-*: backport iconv fixes and improvement from
    upstream master.  Closes: #328303, #1000652.

 -- Aurelien Jarno <aurel32@debian.org>  Tue, 24 Sep 2024 21:46:16 +0200

glibc (2.40-2) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/debhelper.in/libc-dev.install.hurd-amd64: Add missing libm-2.39.a.
  * debian/patches/hurd-i386/git-tst-aligned-alloc-random-thread{,-mcheck}.diff:
    Link threading tests with $(shared-thread-library).
  * debian/testsuite-xfail-debian.mk: Avoid tests overflowing memory.
  * debian/testsuite-xfail-debian.mk: Update hurd xfails.

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch.

 -- Aurelien Jarno <aurel32@debian.org>  Sun, 25 Aug 2024 20:16:17 +0200

glibc (2.40-1) experimental; urgency=medium

  [ Aurelien Jarno ]
  * New upstream release.
    - debian/symbols.wildcards: add 2.40.
    - debian/patches/hurd-i386/git-context.diff: upstreamed.
    - debian/patches/hurd-i386/git-xattr.diff: upstreamed.
    - debian/patches/hurd-i386/git-proc_getchildren_rusage.diff: upstreamed.
    - debian/patches/hurd-i386/git-AT_NO_AUTOMOUNT.diff: upstreamed.
    - debian/patches/hurd-i386/git-intr-msg-clobber.diff: upstreamed.
    - debian/patches/hurd-i386/git-pthread_self.diff: upstreamed.
    - debian/patches/hurd-i386/git-pthread_self.2.diff: upstreamed.
    - debian/patches/hurd-i386/tg-sysvshm.diff: rebased.
    - debian/patches/hurd-i386/tg-sendmsg-SCM_CREDS.diff: rebased.
    - debian/patches/hurd-i386/local-exec_filename.diff: rebased.
    - debian/patches/all/local-remove-manual.diff: refreshed.
    - debian/patches/any/local-cross.patch: refreshed.
    - debian/patches/any/git-test-epoll.diff: upstreamed.

 -- Aurelien Jarno <aurel32@debian.org>  Mon, 22 Jul 2024 07:14:59 +0200

glibc (2.39-7) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/patches/hurd-i386/git-fault-64bit.diff: Fix receiving exceptions.
  * debian/patches/hurd-i386/{tg-sendmsg-SCM_CREDS.diff,tg-ifaddrs_v6.diff}:
    Fix build with gcc-14.
  * debian/sysdeps/hurd-amd64.mk: Enable mvec.
  * debian/libc0.3.symbols.hurd-amd64: Add symbols for libmvec.
  * debian/patches/hurd-i386/git-pthread_symbols.diff: Fix missing symbols.

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fix build with libaudit 4.0.

 -- Aurelien Jarno <aurel32@debian.org>  Wed, 14 Aug 2024 16:06:39 +0200

glibc (2.39-6) unstable; urgency=medium

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fixes elf/check-localplt test on power* with recent binutils.

 -- Aurelien Jarno <aurel32@debian.org>  Tue, 23 Jul 2024 19:09:58 +0200

glibc (2.39-5) unstable; urgency=medium

  [ Samuel Thibault ]
  * debian/patches/hurd-i386/git-pthread_self{,.2}.diff: Fix pthread_self()
    without libpthread.

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - Fixes stdlib/tst-swapcontext2 test on hppa.  Closes: #1076512.
  * debian/rules.d/tarball.mk: remove useless code.
  * debian/sysdeps/arm64.mk: compile with -mbranch-protection=standard on
    arm64 to enable PAC/BTI support.  Closes: #1063515.
  * debian/control.in/main: build-depends on g++13-for-host (>= 13.3.0-3) on
    arm64 to ensure PAC/BTI support in GCC.

 -- Aurelien Jarno <aurel32@debian.org>  Mon, 22 Jul 2024 22:58:49 +0200

glibc (2.39-4) unstable; urgency=medium

  [ Aurelien Jarno ]
  * debian/patches/git-updates.diff: update from upstream stable branch:
    - debian/patches/any/submitted-static-copysignf128.diff: upstreamed.
    - debian/patches/any/submitted-static-fmod-fmodf.diff: upstreamed.
    - debian/patches/any/submitted-static-frexpf128.diff: upstreamed.
    - debian/patches/any/submitted-static-isnanf128.diff: upstreamed.
    - debian/patches/any/submitted-static-modf128.diff: upstreamed.
    - debian/patches/any/submitted-static-exp10.diff: upstreamed.

  [ Samuel Thibault ]
  * debian/testsuite-xfail-debian.mk: Update for upcoming 2.40.
  * debian/debhelper.in/libc-udeb.install.hurd-amd64: Fix missing libhurduser.
  * debian/debhelper.in/libc-udeb.install.hurd-i386: Fix missing libhurduser.
  * debian/patches/hurd-i386/git-intr-msg-clobber.diff: Fix restoring message to be retried.
  * debian/patches/hurd-i386/local-intr-msg-clobber.diff: Fix message-retry overwrite.

 -- Aurelien Jarno <aurel32@debian.org>  Mon, 15 Jul 2024 21:20:54 +0200

glibc (2.39-3.1) experimental; urgency=medium



=== src/sequoia-sq/debian/changelog ===
rust-sequoia-sq (0.40.0-1) unstable; urgency=medium

  * Package sequoia-sq 0.40.0 from crates.io using debcargo 2.7.4
    - refresh patches.
    - drop man-pages dropped upstream, simplify debian/sq.manpages.

 -- Holger Levsen <holger@debian.org>  Fri, 29 Nov 2024 17:29:35 +0100

rust-sequoia-sq (0.38.0-3) unstable; urgency=medium

  * Package sequoia-sq 0.38.0 from crates.io using debcargo 2.7.0
    - ship upstream manpages and shell completions, generated at build time.

 -- Holger Levsen <holger@debian.org>  Sun, 13 Oct 2024 18:40:36 +0200

rust-sequoia-sq (0.38.0-2) unstable; urgency=medium

  * Package sequoia-sq 0.38.0 from crates.io using debcargo 2.7.0
    - relax dependencies to allow build with -policy-config 0.7.

 -- Holger Levsen <holger@debian.org>  Sat, 12 Oct 2024 13:38:34 +0200

rust-sequoia-sq (0.38.0-1) unstable; urgency=medium

  * Team upload.
  * Package sequoia-sq 0.38.0 from crates.io using debcargo 2.7.0 (Closes: #1081757)
  * Update patches for new upstream.

 -- Peter Michael Green <plugwash@debian.org>  Tue, 24 Sep 2024 08:39:42 +0000

rust-sequoia-sq (0.37.0-1) unstable; urgency=medium

  * Team upload.
  * Package sequoia-sq 0.37.0 from crates.io using debcargo 2.6.1 (Closes: #1074679)
  * Bump sequoia-openpgp dependency to pick up the fix for RUSTSEC-2024-0345

  [ Holger Levsen ]
  * Package sequoia-sq 0.37.0 from crates.io using debcargo 2.6.1.
    Closes: #1073408.
  * Add Alexander and myself to uploaders.

  [ Alexander Kjäll ]
  * Package sequoia-sq 0.34.0 from crates.io using debcargo 2.6.1
  * Add man pages and bash completion to sequoia-sq.

 -- Peter Michael Green <plugwash@debian.org>  Tue, 23 Jul 2024 13:47:04 +0000

rust-sequoia-sq (0.33.0-2) unstable; urgency=medium

  * Team upload.
  * Package sequoia-sq 0.33.0 from crates.io using debcargo 2.6.1
  * Relax itertools dependency.

 -- Peter Michael Green <plugwash@debian.org>  Sat, 27 Jan 2024 18:26:29 +0000

rust-sequoia-sq (0.33.0-1) unstable; urgency=medium

  * Team upload.
  * Package sequoia-sq 0.33.0 from crates.io using debcargo 2.6.1
  * Update copyright file for upstream license change.
  * Fix installation of shell completion files with new upstream version.

 -- Peter Michael Green <plugwash@debian.org>  Thu, 25 Jan 2024 13:50:54 +0000

rust-sequoia-sq (0.31.0-2) unstable; urgency=medium

  * Team upload.
  * Package sequoia-sq 0.31.0 from crates.io using debcargo 2.6.1
  * Stop patching rpassword dependency.

 -- Peter Michael Green <plugwash@debian.org>  Mon, 27 Nov 2023 22:46:50 +0000

rust-sequoia-sq (0.31.0-1) unstable; urgency=medium

  * Team upload.
  * Package sequoia-sq 0.31.0 from crates.io using debcargo 2.6.0 (Closes: #1040959, #1042209)
  * Update drop-subplot.patch for new upstream.
  * Drop relax-serde_json.patch and rpassword-6.patch, no longer needed.
  * Revert upstream bump of rpassword from 6 to 7.
  * Drop reference to manpage that no longer seems to exist.

 -- Peter Michael Green <plugwash@debian.org>  Tue, 07 Nov 2023 21:58:44 +0000

rust-sequoia-sq (0.27.0-2) unstable; urgency=medium

  * Team upload.
  * Package sequoia-sq 0.27.0 from crates.io using debcargo 2.6.0
  * Apply upstream patch for rpassword 6.

 -- Peter Michael Green <plugwash@debian.org>  Thu, 09 Feb 2023 04:32:50 +0000

rust-sequoia-sq (0.27.0-1) unstable; urgency=medium

  * Package sequoia-sq 0.27.0 from crates.io using debcargo 2.5.0

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Wed, 20 Jul 2022 01:12:11 -0400

rust-sequoia-sq (0.26.0-3) unstable; urgency=medium

  * Team upload.
  * Package sequoia-sq 0.26.0 from crates.io using debcargo 2.5.0
  * Bump dependency on sequoia-net to 0.25 (Closes: #1015109)

 -- Peter Michael Green <plugwash@debian.org>  Sun, 17 Jul 2022 01:55:48 +0000

rust-sequoia-sq (0.26.0-2) unstable; urgency=medium

  * Package sequoia-sq 0.26.0 from crates.io using debcargo 2.5.0
  * Ship correct manpages now that the net feature is enabled.

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 08 Jul 2022 15:04:23 -0400

rust-sequoia-sq (0.26.0-1) unstable; urgency=medium

  * Package sequoia-sq 0.26.0 from crates.io using debcargo 2.5.0
  * drop subplot tests since subplot is not in debian

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 08 Jul 2022 02:36:56 -0400

rust-sequoia-sq (0.25.0-3) unstable; urgency=medium

  * Team upload.
  * Package sequoia-sq 0.25.0 from crates.io using debcargo 2.5.0
  * Relax dependency on sequoia-autocrypt.

 -- Peter Michael Green <plugwash@debian.org>  Tue, 14 Dec 2021 13:03:46 +0000

rust-sequoia-sq (0.25.0-2) unstable; urgency=medium

  * Team upload.
  * Package sequoia-sq 0.25.0 from crates.io using debcargo 2.4.4

 -- Peter Michael Green <plugwash@debian.org>  Sun, 24 Oct 2021 17:14:53 +0000

rust-sequoia-sq (0.25.0-1) unstable; urgency=medium

  * Package sequoia-sq 0.25.0 from crates.io using debcargo 2.4.4

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Fri, 05 Mar 2021 19:34:07 -0500

rust-sequoia-sq (0.24.0-4) unstable; urgency=medium

  * Package sequoia-sq 0.24.0 from crates.io using debcargo 2.4.3
  * Enable autocrypt functionality

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 04 Feb 2021 08:48:17 -0500

rust-sequoia-sq (0.24.0-3) unstable; urgency=medium

  * Package sequoia-sq 0.24.0 from crates.io using debcargo 2.4.3
  * indicate Breaks/Replaces: ispell (<< 3.4.00-6.1~) (Closes: #981579)
    Thanks, Andreas Beckmann!

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Mon, 01 Feb 2021 20:23:35 -0500

rust-sequoia-sq (0.24.0-2) unstable; urgency=medium

  * Package sequoia-sq 0.24.0 from crates.io using debcargo 2.4.3
  * No-op source-only re-upload for Debian Testing Migration.

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Sat, 30 Jan 2021 23:05:22 -0500

rust-sequoia-sq (0.24.0-1) unstable; urgency=medium

  * Package sequoia-sq 0.24.0 from crates.io using debcargo 2.4.3
    (Closes: #929385)

 -- Daniel Kahn Gillmor <dkg@fifthhorseman.net>  Thu, 28 Jan 2021 17:27:10 -0500

=== debian/control ===
Source: gcc-14
Section: devel
Priority: optional
Maintainer: Debian GCC Maintainers <debian-gcc@lists.debian.org>
Uploaders: Matthias Klose <doko@debian.org>
Standards-Version: 4.6.2
Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.17.14), g++-multilib [amd64 i386 mips mips64 mips64el mips64r6 mips64r6el mipsel mipsn32 mipsn32el mipsn32r6 mipsn32r6el mipsr6 mipsr6el powerpc ppc64 s390 s390x sparc sparc64 x32] <!cross>,
  libc6.1-dev (>= 2.23-1~) [alpha ia64] | libc0.3-dev (>= 2.23-1~) [hurd-amd64 hurd-i386] | libc6-dev (>= 2.23-1~), libc6-dev-amd64 [i386 x32], libc6-dev-sparc64 [sparc], libc6-dev-sparc [sparc64], libc6-dev-s390 [s390x], libc6-dev-s390x [s390], libc6-dev-i386 [amd64 x32], libc6-dev-powerpc [ppc64], libc6-dev-ppc64 [powerpc], lib32gcc-s1 [amd64 ppc64 mipsn32 mipsn32el mips64 mips64el mipsn32r6 mipsn32r6el mips64r6 mips64r6el s390x sparc64 x32], libn32gcc-s1 [mips mipsel mips64 mips64el mipsr6 mipsr6el mips64r6 mips64r6el], lib64gcc-s1 [i386 mips mipsel mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el powerpc sparc s390 x32], libc6-dev-mips64 [mips mipsel mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el], libc6-dev-mipsn32 [mips mipsel mips64 mips64el mipsr6 mipsr6el mips64r6 mips64r6el], libc6-dev-mips32 [mipsn32 mipsn32el mips64 mips64el mipsn32r6 mipsn32r6el mips64r6 mips64r6el], libc6-dev-x32 [amd64 i386], libx32gcc-s1 [amd64 i386], libc6.1-dbg [alpha ia64] | libc0.3-dbg [hurd-amd64 hurd-i386] | libc6-dbg,
  linux-libc-dev [m68k],
  m4, libtool, autoconf2.69,
  dwz, libunwind8-dev [ia64], libatomic-ops-dev [ia64],
  gawk, lzma, xz-utils, patchutils,
  libzstd-dev, zlib1g-dev, systemtap-sdt-dev [linux-any],
  binutils:native (>= 2.37), binutils-hppa64-linux-gnu:native (>= 2.37) [hppa amd64 i386 x32],
  gperf, bison, flex,
  gettext, nvptx-tools [amd64 arm64 ppc64el], amdgcn-tools-18 [amd64],
  texinfo, locales-all, sharutils,
  procps, gnat-13:native [!arc !ia64 !sh3 !sh3eb !sh4eb], g++-13:native, netbase, gdc-13:native [!arc !ia64 !m68k !sh4 !s390 !sparc64 !alpha !hurd-alpha !hurd-amd64 !hurd-i386], python3:any, cargo [!hppa !ia64 !m68k !sh4 !x32 !alpha !hurd-alpha !hurd-amd64 !hurd-i386],
  libisl-dev (>= 0.20), libmpc-dev (>= 1.0), libmpfr-dev (>= 3.0.0-9~), libgmp-dev (>= 2:5.0.1~), lib32z1-dev [amd64], lib64z1-dev [i386], unzip <!nocheck>,
  dejagnu <!nocheck>, coreutils, chrpath, lsb-release, quilt, time,
  pkg-config, libgc-dev,
  g++-14-for-host <cross>, gobjc-14-for-host [!avr] <cross>, gfortran-14-for-host <cross>, gdc-14-for-host [!arc !ia64 !m68k !sh4 !s390 !sparc64 !alpha !hurd-alpha !hurd-amd64 !hurd-i386] <cross>, gccgo-14-for-host [!arc !avr !hppa !loong64 !m68k !sh4] <cross>, gnat-14-for-host [!arc !ia64 !sh3 !sh3eb !sh4eb] <cross>, gm2-14-for-host [!powerpc !ppc64 !sh4] <cross>,
Build-Depends-Indep: doxygen <!nodoc>, graphviz <!nodoc>, ghostscript <!nodoc>, texlive-latex-base <!nodoc>, xsltproc <!nodoc>, libxml2-utils <!nodoc>, docbook-xsl-ns <!nodoc>,
Homepage: http://gcc.gnu.org/
Vcs-Browser: https://salsa.debian.org/toolchain-team/gcc
Vcs-Git: https://salsa.debian.org/toolchain-team/gcc.git
XS-Testsuite: autopkgtest

Package: gcc-14-base
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends}
Replaces: ${base:Replaces}
Breaks: ${base:Breaks}
Description: GCC, the GNU Compiler Collection (base package)
 This package contains files common to all languages and libraries
 contained in the GNU Compiler Collection (GCC).

Package: libgcc-s1
X-DH-Build-For-Type: target
Architecture: any
Section: libs
Depends: gcc-14-base (= ${gcc:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: libgcc1 (= ${gcc:EpochVersion}),
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
XB-Important: yes
Protected: yes
Breaks: ${libgcc:Breaks}
Replaces: libgcc1 (<< 1:10)
Description: GCC support library
 Shared version of the support library, a library of internal subroutines
 that GCC uses to overcome shortcomings of particular machines, or
 special needs for some languages.

Package: libgcc-s2
X-DH-Build-For-Type: target
Architecture: m68k
Section: libs
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
XB-Important: yes
Protected: yes
Depends: gcc-14-base (= ${gcc:Version}), ${shlibs:Depends}, ${misc:Depends}
Provides: libgcc2 (= ${gcc:EpochVersion}),
Breaks: ${libgcc:Breaks}
Replaces: libgcc2 (<< 1:10)
Description: GCC support library
 Shared version of the support library, a library of internal subroutines
 that GCC uses to overcome shortcomings of particular machines, or
 special needs for some languages.

Package: libgcc-s4
X-DH-Build-For-Type: target
Architecture: hppa
Multi-Arch: same
XB-Important: yes
Protected: yes
Pre-Depends: ${misc:Pre-Depends}
Provides: libgcc4 (= ${gcc:EpochVersion})
Breaks: ${libgcc:Breaks}
Replaces: libgcc4 (<< 1:10)
Section: libs
Depends: gcc-14-base (= ${gcc:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: GCC support library
 Shared version of the support library, a library of internal subroutines
 that GCC uses to overcome shortcomings of particular machines, or
 special needs for some languages.

Package: libgcc-14-dev
X-DH-Build-For-Type: target
Architecture: any
Section: libdevel
Recommends: ${dep:libcdev}
Depends: gcc-14-base (= ${gcc:Version}), ${dep:libgcc}, ${dep:libssp}, ${dep:libgomp}, ${dep:libitm},
 ${dep:libatomic}, ${dep:libbtrace}, ${dep:libasan}, ${dep:liblsan},
 ${dep:libtsan}, ${dep:libubsan}, ${dep:libhwasan}, ${dep:libvtv},
 ${dep:libqmath}, ${dep:libunwinddev}, ${shlibs:Depends}, ${misc:Depends}
Breaks: libtsan2 (<< 12-20211113-2~)
Replaces: libtsan2 (<< 12-20211113-2~)
Multi-Arch: same
Description: GCC support library (development files)
 This package contains the headers and static library files necessary for
 building C programs which use libgcc, libgomp, libquadmath, libssp or libitm.

Package: lib64gcc-s1
X-DH-Build-For-Type: target
Architecture: i386 powerpc sparc s390 mips mipsel mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el x32
Section: libs
Depends: gcc-14-base (= ${gcc:Version}), ${dep:libcbiarch}, ${misc:Depends}
Breaks: lib64gcc1 (<< 1:10)
Replaces: lib64gcc1 (<< 1:10)
Description: GCC support library (64bit)
 Shared version of the support library, a library of internal subroutines
 that GCC uses to overcome shortcomings of particular machines, or
 special needs for some languages.

Package: lib64gcc-14-dev
X-DH-Build-For-Type: target
Architecture: i386 powerpc sparc s390 mips mipsel mipsn32 mipsn32el mipsr6 mipsr6el mipsn32r6 mipsn32r6el x32
Section: libdevel
Recommends: ${dep:libcdev}
Depends: gcc-14-base (= ${gcc:Version}), ${dep:libgccbiarch}, ${dep:libsspbiarch},
 ${dep:libgompbiarch}, ${dep:libitmbiarch}, ${dep:libatomicbiarch},
 ${dep:libbtracebiarch}, ${dep:libasanbiarch}, ${dep:liblsanbiarch},
 ${dep:libtsanbiarch}, ${dep:libubsanbiarch}, ${dep:libhwasanbiarch},
 ${dep:libvtvbiarch},
 ${dep:libqmathbiarch}, ${shlibs:Depends}, ${misc:Depends}
Description: GCC support library (64bit development files)
 This package contains the headers and static library files necessary for
 building C programs which use libgcc, libgomp, libquadmath, libssp or libitm.

Package: lib32gcc-s1
X-DH-Build-For-Type: target
Architecture: amd64 ppc64 s390x sparc64 x32 mipsn32 mipsn32el mips64 mips64el mipsn32r6 mipsn32r6el mips64r6 mips64r6el
Section: libs
Depends: gcc-14-base (= ${gcc:Version}), ${dep:libcbiarch}, ${misc:Depends}
Conflicts: ${confl:lib32}
Breaks: lib32gcc1 (<< 1:10)
Replaces: lib32gcc1 (<< 1:10)
Description: GCC support library (32 bit Version)
 Shared version of the support library, a library of internal subroutines
 that GCC uses to overcome shortcomings of particular machines, or
 special needs for some languages.

Package: lib32gcc-14-dev
X-DH-Build-For-Type: target
Architecture: amd64 ppc64 s390x sparc64 x32 mipsn32 mipsn32el mips64 mips64el mipsn32r6 mipsn32r6el mips64r6 mips64r6el
Section: libdevel
Recommends: ${dep:libcdev}
Depends: gcc-14-base (= ${gcc:Version}), ${dep:libgccbiarch}, ${dep:libsspbiarch},
 ${dep:libgompbiarch}, ${dep:libitmbiarch}, ${dep:libatomicbiarch},
 ${dep:libbtracebiarch}, ${dep:libasanbiarch}, ${dep:liblsanbiarch},
 ${dep:libtsanbiarch}, ${dep:libubsanbiarch}, ${dep:libhwasanbiarch},
 ${dep:libvtvbiarch},
 ${dep:libqmathbiarch}, ${shlibs:Depends}, ${misc:Depends}
Description: GCC support library (32 bit development files)
 This package contains the headers and static library files necessary for
 building C programs which use libgcc, libgomp, libquadmath, libssp or libitm.

Package: libn32gcc-s1
X-DH-Build-For-Type: target
Architecture: mips mipsel mips64 mips64el mipsr6 mipsr6el mips64r6 mips64r6el
Section: libs
Depends: gcc-14-base (= ${gcc:Version}), ${dep:libcbiarch}, ${misc:Depends}
Breaks: libn32gcc1 (<< 1:10)
Replaces: libn32gcc1 (<< 1:10)
Description: GCC support library (n32)
 Shared version of the support library, a library of internal subroutines
 that GCC uses to overcome shortcomings of particular machines, or
 special needs for some languages.

Package: libn32gcc-14-dev
X-DH-Build-For-Type: target
Architecture: mips mipsel mips64 mips64el mipsr6 mipsr6el mips64r6 mips64r6el
Section: libdevel
Recommends: ${dep:libcdev}
Depends: gcc-14-base (= ${gcc:Version}), ${dep:libgccbiarch}, ${dep:libsspbiarch},
 ${dep:libgompbiarch}, ${dep:libitmbiarch}, ${dep:libatomicbiarch},
 ${dep:libbtracebiarch}, ${dep:libasanbiarch}, ${dep:liblsanbiarch},
 ${dep:libtsanbiarch}, ${dep:libubsanbiarch}, ${dep:libhwasanbiarch},
 ${dep:libvtvbiarch},
 ${dep:libqmathbiarch}, ${shlibs:Depends}, ${misc:Depends}
Description: GCC support library (n32 development files)
 This package contains the headers and static library files necessary for
 building C programs which use libgcc, libgomp, libquadmath, libssp or libitm.

Package: libx32gcc-s1
X-DH-Build-For-Type: target
Architecture: amd64 i386
Section: libs
Depends: gcc-14-base (= ${gcc:Version}), ${dep:libcbiarch}, ${misc:Depends}
Breaks: libx32gcc1 (<< 1:10)
Replaces: libx32gcc1 (<< 1:10)
Description: GCC support library (x32)
 Shared version of the support library, a library of internal subroutines
 that GCC uses to overcome shortcomings of particular machines, or
 special needs for some languages.

Package: libx32gcc-14-dev
X-DH-Build-For-Type: target
Architecture: amd64 i386
Section: libdevel
Recommends: ${dep:libcdev}
Depends: gcc-14-base (= ${gcc:Version}), ${dep:libgccbiarch}, ${dep:libsspbiarch},
 ${dep:libgompbiarch}, ${dep:libitmbiarch}, ${dep:libatomicbiarch},
 ${dep:libbtracebiarch}, ${dep:libasanbiarch}, ${dep:liblsanbiarch},
 ${dep:libtsanbiarch}, ${dep:libubsanbiarch}, ${dep:libhwasanbiarch},
 ${dep:libvtvbiarch},
 ${dep:libqmathbiarch}, ${shlibs:Depends}, ${misc:Depends}
Description: GCC support library (x32 development files)
 This package contains the headers and static library files necessary for
 building C programs which use libgcc, libgomp, libquadmath, libssp or libitm.

Package: gcc-14-alpha-linux-gnu
Architecture: alpha
Multi-Arch: foreign
Depends: cpp-14-alpha-linux-gnu (= ${gcc:Version}), gcc-14-base (= ${gcc:Version}),
    ${dep:libcc1},
  binutils-alpha-linux-gnu (>= ${binutils:Version}),
  ${dep:libgccdev}, ${shlibs:Depends}, ${misc:Depends}
Recommends: ${dep:libcdev}
Suggests: gcc-14-doc (>= ${gcc:SoftVersion}),
 gcc-14-locales (>= ${gcc:SoftVersion}),
Provides: c-compiler-alpha-linux-gnu
Description: GNU C compiler for the alpha-linux-gnu architecture
 This is the GNU C compiler for the alpha-linux-gnu architecture,
 a fairly portable optimizing compiler for C.

Package: gcc-14-x86-64-linux-gnu
Architecture: amd64
Multi-Arch: foreign
Depends: cpp-14-x86-64-linux-gnu (= ${gcc:Version}), gcc-14-base (= ${gcc:Version}),
    ${dep:libcc1},
  binutils-x86-64-linux-gnu (>= ${binutils:Version}),
  ${dep:libgccdev}, ${shlibs:Depends}, ${misc:Depends}
Recommends: ${dep:libcdev}
Suggests: gcc-14-doc (>= ${gcc:SoftVersion}),
 gcc-14-locales (>= ${gcc:SoftVersion}),
Provides: c-compiler-x86-64-linux-gnu

=== debian/rules ===
#! /usr/bin/make -f

#export DH_VERBOSE = 1
#export DEB_BUILD_OPTIONS = nostrip

export LC_ALL = C.UTF-8

include /usr/share/dpkg/default.mk
include /usr/share/debhelper/dh_package_notes/package-notes.mk

ifeq ($(DEB_VENDOR),Ubuntu)
    DEFAULT_NTP_SERVERS = ntp.ubuntu.com
    SUPPORT_URL = http://www.ubuntu.com/support
    CONFFLAGS_DISTRO =
else
    DEFAULT_NTP_SERVERS = 0.debian.pool.ntp.org 1.debian.pool.ntp.org 2.debian.pool.ntp.org 3.debian.pool.ntp.org
    SUPPORT_URL = https://www.debian.org/support
    CONFFLAGS_DISTRO =
endif

TEST_TIMEOUT_MULTIPLIER = "-t 10"

# Fail on missing files and symbol changes on distro builds, but not if we
# build/test upstream master. Also, don't put the debian revision in the version
# tag when we build/test upstream as it doesn't have any meaning in that case
# and it allows using the current date as the debian revision without causing
# unnecessary rebuilds all the time.
ifeq (, $(filter pkg.systemd.upstream, $(DEB_BUILD_PROFILES)))
    DH_MISSING ?= --fail-missing
    GENSYMBOLS_LEVEL = 4
    VERSION_TAG = $(DEB_VERSION)
else
    DH_MISSING ?= --list-missing
    GENSYMBOLS_LEVEL = 1
    VERSION_TAG = $(DEB_VERSION_UPSTREAM)
endif

# Make sure that DEB_BUILD_OPTIONS can be used by users to override any options
# we set here (By default DEB_BUILD_MAINT_OPTIONS overrides DEB_BUILD_OPTIONS).
export DEB_BUILD_MAINT_OPTIONS = optimize=+lto hardening=+pie $(DEB_BUILD_OPTIONS)

CONFFLAGS = \
	-Dstatic-libsystemd=true \
	-Dmode=release \
	-Dversion-tag="$(VERSION_TAG)" \
	-Dquotaon-path=/usr/sbin/quotaon \
	-Dquotacheck-path=/usr/sbin/quotacheck \
	-Dkmod-path=/usr/bin/kmod \
	-Dkexec-path=/usr/sbin/kexec \
	-Dsulogin-path=/usr/sbin/sulogin \
	-Dmount-path=/usr/bin/mount \
	-Dumount-path=/usr/bin/umount \
	-Dloadkeys-path=/usr/bin/loadkeys \
	-Dsetfont-path=/usr/bin/setfont \
	-Dnologin-path=/usr/sbin/nologin \
	-Dsysvinit-path=/etc/init.d \
	-Dsysvrcnd-path=/etc \
	-Dlocalegen-path=/usr/sbin/locale-gen \
	-Ddebug-shell=/usr/bin/bash \
	-Dzshcompletiondir=/usr/share/zsh/vendor-completions \
	-Ddbuspolicydir=/usr/share/dbus-1/system.d/ \
	-Dsupport-url=$(SUPPORT_URL) \
	-Ddefault-kill-user-processes=false \
	-Ddefault-dnssec=no \
	-Dpamconfdir=no \
	-Dpamlibdir=/usr/lib/$(DEB_HOST_MULTIARCH)/security \
	-Drpmmacrosdir=no \
	-Dvconsole=false \
	-Dfirstboot=true \
	-Dxkbcommon=disabled \
	-Dwheel-group=false \
	-Doomd=true \
	-Durlify=true \
	-Dgnutls=disabled \
	-Dlink-udev-shared=false \
	-Dlink-systemctl-shared=false \
	-Dbump-proc-sys-fs-nr-open=false \
	-Dntp-servers="$(DEFAULT_NTP_SERVERS)" \
	-Ddns-servers='' \
	-Dsystem-uid-max=999 \
	-Dsystem-gid-max=999 \
	-Dnobody-user=nobody \
	-Dnobody-group=nogroup \
	-Ddev-kvm-mode=0660 \
	-Dgroup-render-mode=0660 \
	-Drepart=enabled \
	-Dfdisk=enabled \
	-Dsysext=true \
	-Dnscd=true \
	-Dselinux=enabled \
	-Dhwdb=true \
	-Dsysusers=true \
	-Dinstall-tests=$(if $(filter noinsttest,$(DEB_BUILD_PROFILES)),false,true) \
	-Dman=$(if $(filter nodoc,$(DEB_BUILD_PROFILES)),disabled,enabled) \
	-Dtranslations=true \
	-Dnss-myhostname=true \
	-Dnss-mymachines=enabled \
	-Dnss-resolve=enabled \
	-Dnss-systemd=true \
	-Dresolve=true \
	-Dstatus-unit-format-default=combined \
	-Dstandalone-binaries=true \
	-Dmode=$(if $(filter pkg.systemd.upstream,$(DEB_BUILD_PROFILES)),developer,release)

ifeq ($(filter nocheck,$(DEB_BUILD_PROFILES))$(filter noinsttest,$(DEB_BUILD_PROFILES)),nochecknoinsttest)
CONFFLAGS += -Dtests=false
else
CONFFLAGS += -Dtests=true
endif

ifeq (, $(filter stage1, $(DEB_BUILD_PROFILES)))
CONFFLAGS += \
	-Daudit=enabled \
	-Dlibcryptsetup=enabled \
	-Dlibcryptsetup-plugins=enabled \
	-Dcoredump=true \
	-Delfutils=enabled \
	-Dapparmor=enabled \
	-Dlibidn2=enabled \
	-Dlibiptc=enabled \
	-Dlibcurl=enabled \
	-Dimportd=enabled \
	-Dmicrohttpd=enabled \
	-Dopenssl=enabled \
	-Dcryptolib=openssl \
	-Ddns-over-tls=openssl \
	-Dlibfido2=enabled \
	-Dtpm2=enabled \
	-Dp11kit=enabled \
	-Dqrencode=enabled \
	-Dpwquality=enabled \
	-Dhomed=enabled \
	-Duserdb=true \
	-Dpcre2=enabled \
	-Dukify=enabled \
	-Dbootloader=$(if $(filter x32,$(DEB_HOST_ARCH)),disabled,auto) \
	-Dsysupdate=enabled
else
CONFFLAGS += \
	-Daudit=disabled \
	-Dlibcryptsetup=disabled \
	-Dlibcryptsetup-plugins=disabled \
	-Dcoredump=false \
	-Delfutils=disabled \
	-Dapparmor=disabled \
	-Dlibidn2=disabled \
	-Dlibiptc=disabled \
	-Dlibcurl=disabled \
	-Dimportd=disabled \
	-Dmicrohttpd=disabled \
	-Dopenssl=disabled \
	-Dlibfido2=disabled \
	-Dtpm2=disabled \
	-Dp11kit=disabled \
	-Dqrencode=disabled \
	-Dpwquality=disabled \
	-Dhomed=disabled \
	-Duserdb=false \
	-Dpcre2=disabled \
	-Dukify=disabled \
	-Dbootloader=disabled \
	-Dsysupdate=disabled
endif

# BPF/BTF are only enabled and usable on a few architectures
ifeq (, $(filter $(DEB_BUILD_PROFILES), stage1 pkg.systemd.nobpf))
ifneq (,$(filter $(DEB_TARGET_ARCH), amd64 arm64 ppc64el riscv64 s390x))
CONFFLAGS += \
	-Dbpf-framework=enabled \
	-Dbpf-compiler=clang

ifeq ($(DEB_VENDOR),Ubuntu)
# Source: https://git.launchpad.net/ubuntu/+source/xdp-tools/tree/debian/rules
# On Ubuntu, the `bpftool` in path is a shell wrapper pointing at
# the binary corresponding to runtime kernel version.
#
# We do not know the kernel version being used on the system building
# this package, and in sbuild/container environments uname might not
# even match anything available to the build.
# Gladly for the build we only need the tool to generate skeleton code.
#
# If any /usr/lib/linux-tools/*/bpftool exists, locate the most recent
# version and point to that, otherwise `bpftool` from PATH will be
# used.
bpftool_binary := $(shell find /usr/lib/linux-tools/ -name 'bpftool' -perm /u=x 2>/dev/null | sort | head -n1)
ifneq ($(bpftool_binary),)
export PATH := $(shell dirname $(bpftool_binary)):$(PATH)
endif
endif

# The vmlinux.h we want is in the headers package that linux-headers-ARCH depends on,
# which itself is the package that provides linux-headers-generic that we build depend on.
# This is available since Trixie. If we can't find it, default to auto for the upstream CI
# so that it is generated at build time, or disabled for distribution builds, as we don't
# want to depend on the buildd kernels.
ifeq ($(DEB_VENDOR),Ubuntu)
HEADERS_PACKAGE = $(shell dpkg-query --showformat='$${Depends}' --show linux-headers-generic | sed "s/.*\(linux-headers-.*)\)-generic.*/\1/")
else
HEADERS_PACKAGE = $(shell dpkg-query --showformat='$${Depends}' --show linux-headers-$(DEB_HOST_ARCH) | sed "s/.*\(linux-headers-.*-$(DEB_HOST_ARCH)\).*/\1/")
endif

ifneq ("$(wildcard /usr/src/$(HEADERS_PACKAGE)/vmlinux.h)","")
CONFFLAGS += -Dvmlinux-h=provided -Dvmlinux-h-path=/usr/src/$(HEADERS_PACKAGE)/vmlinux.h
else
ifneq (, $(filter pkg.systemd.upstream, $(DEB_BUILD_PROFILES)))
CONFFLAGS += -Dvmlinux-h=auto
else
CONFFLAGS += -Dvmlinux-h=disabled
endif
endif
endif
endif

override_dh_auto_configure:
	dh_auto_configure \
		-- $(CONFFLAGS) $(CONFFLAGS_DISTRO) $(CONFFLAGS_UPSTREAM)

execute_before_dh_auto_build:
	# blhc false positives: C++ fuzz test program, cc -E flags listing, PE-COFF EFI binaries
	@echo 'blhc: ignore-line-regexp: .* -o test-bus-vtable-cc.*'
	@echo 'blhc: ignore-line-regexp: .*cc -E.*'
	@echo 'blhc: ignore-line-regexp: .* -o src/boot/efi.*'

execute_after_dh_auto_build:
	# generate POT file for translators
	ninja -C obj-$(DEB_HOST_GNU_TYPE) systemd-pot

execute_before_dh_auto_clean:
ifneq (, $(filter pkg.systemd.upstream, $(DEB_BUILD_PROFILES)))
	debian/extra/checkout-upstream
endif

execute_after_dh_auto_clean:
	rm -f debian/shlibs.local
	# remove Python byte code files
	rm -rf src/ukify/test/__pycache__/
	rm -rf src/ukify/__pycache__/
	rm -rf tools/__pycache__/
	rm -rf tools/chromiumos/__pycache__/
	rm -f po/systemd.pot

execute_before_dh_install:
	# remove unnecessary / unused files
	rm -rf debian/tmp/usr/share/doc/systemd/LICENSES/
	rm -f debian/tmp/usr/share/doc/systemd/LICENSE.*
	rm -f debian/tmp/etc/init.d/README
	rm -f debian/tmp/usr/lib/*.d/README

=== debian/tests/control ===
Tests: timedated, hostnamed, localed-locale, localed-x11-keymap, logind
Depends: systemd,
  systemd-resolved,
  systemd-timesyncd,
  libpam-systemd,
  libnss-systemd,
  acl,
  locales,
  evemu-tools,
Restrictions: needs-root, isolation-container, skippable, breaks-testbed

Tests: unit-config
Depends: systemd,
  systemd-resolved,
  libpam-systemd,
  libnss-systemd,
  acl,
  locales,
  evemu-tools,
  python3,
  pkgconf,
Restrictions: needs-root, allow-stderr, breaks-testbed

Tests: storage
Depends: systemd,
  systemd-resolved,
  libpam-systemd,
  libnss-systemd,
  acl,
  locales,
  evemu-tools,
  python3,
  pkgconf,
  cryptsetup-bin,
Restrictions: needs-root, isolation-machine, breaks-testbed

Tests: networkd-test.py
Tests-Directory: test
Depends: systemd,
  systemd-resolved,
  libpam-systemd,
  libnss-systemd,
  acl,
  locales,
  evemu-tools,
  python3,
  pkgconf,
  cryptsetup-bin,
  systemd-sysv,
  polkitd,
  netlabel-tools,
  dnsmasq-base
Restrictions: needs-root, isolation-container, breaks-testbed

Tests: build-login
Depends: systemd,
  systemd-resolved,
  libpam-systemd,
  libnss-systemd,
  acl,
  locales,
  evemu-tools,
  python3,
  pkgconf,
  cryptsetup-bin,
  systemd-sysv,
  polkitd,
  dnsmasq-base,
  build-essential,
  libsystemd-dev,
Restrictions: isolation-container

Tests: boot-and-services
Depends: systemd-sysv,
  systemd-container,
  systemd-coredump,
  systemd-resolved,
  libpam-systemd,
  libdw-dev,
  libelf-dev,
  xserver-xorg-video-dummy,
  xserver-xorg,
  gdm3 [!s390x],
  cron,
  network-manager,
  busybox-static,
  rsyslog,
  apparmor,
  pkgconf,
  python3,
  python3-pefile,
  dhcpcd-base | dhcpcd5,
Restrictions: needs-root, isolation-container, breaks-testbed, allow-stderr

Tests: unit-tests
Depends: systemd-tests,
  systemd-resolved,
  libpam-systemd,
  libnss-myhostname,
  libnss-mymachines,
  libnss-resolve,
  libnss-systemd,
  udev,
  tree,
  perl,
  python3,
  python3-colorama,
  python3-pefile,
  xz-utils,
  libcap2-bin,
  iproute2,
  lz4,
  acl,
  iputils-ping,
  dbus-user-session,
  zstd,
  libtss2-dev,
  libfido2-dev,
  libdw-dev,
  libqrencode-dev,
  libpwquality-dev,
  libarchive-dev,
  libgcrypt20-dev,
  tzdata-legacy | tzdata (<< 2024a-1),
Restrictions: needs-root, isolation-container, breaks-testbed

Tests: upstream
Depends: systemd-tests,
  systemd-journal-remote,
  systemd-container,
  systemd-coredump,
  systemd-timesyncd,
  systemd-oomd,
  systemd-homed,
  systemd-resolved,
  systemd-boot-efi [amd64 arm64 armhf i386 riscv64],
  libnss-myhostname,
  libnss-mymachines,
  libnss-resolve,
  libnss-systemd,
  attr,
  tree,
  perl,
  xz-utils,
  libcap2-bin,
  iproute2,
  lz4,
  acl,
  dmeventd,
  kbd,
  cryptsetup-bin,
  cryptsetup-initramfs,
  net-tools,
  isc-dhcp-client,
  iputils-ping,
  strace,
  qemu-system-x86 [amd64 i386],
  qemu-system-arm [arm64 armhf],
  qemu-system-ppc [ppc64el],
  qemu-system-s390x [s390x],
  seabios,
  less,
  pkgconf,
  gcc,
  libc6-dev | libc-dev,
  make,
  quota,
  fdisk,

=== debian/watch ===
version=4
  https://github.com/PCRE2Project/pcre2/releases .*/?(\d{2}\.\d{2})\.tar\.gz
